volunteer_mgmt/urls.py
from django.conf.urls import include, url
from django.conf.urls.static import static
import volunteers.views as views
from volunteers.views import *
from django.contrib import admin
admin.autodiscover()

urlpatterns = [
    # Examples:
    # url(r'^$', 'volunteer_mgmt.views.home', name='home'),
    # url(r'^volunteer_mgmt/', include('volunteer_mgmt.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    url(r'^admin/', include(admin.site.urls)),
    # Userena urls:
    url(r'^$', promo, name='promo'),
    url(r'^volunteers/signup', signup, name='signup'),
    url(r'^volunteers/(?P<username>(?!signout|signup|signin)[\.\w-]+)/$', profile_detail, name='profile_detail'),
    url(r'^volunteers/(?P<username>[\.\w-]+)/edit/$', profile_edit, name='userena_profile_edit'),
    url(r'^volunteers/page/(?P<page>[0-9]+)/$', views.ProfileListView.as_view(), name='userena_profile_list_paginated'),
    url(r'^volunteers/$', views.ProfileListView.as_view(), name='userena_profile_list'),
    url(r'^volunteers/', include('userena.urls')),
    url(r'^messages/', include('userena.contrib.umessages.urls')),
    # other urls:
    url(r'^tasks/(?P<username>[\.\w-]+)', task_list_detailed, name='task_list_detailed'),
    url(r'^task/(?P<task_id>\d+)/$', task_detailed, name='task_detailed'),
    url(r'^tasks/', task_list, name='task_list'),
    url(r'^event_sign_on/', event_sign_on, name='event_sign_on'),
    url(r'^category_schedule/', category_schedule_list, name='category_schedule_list'),
    url(r'^task_schedule/(?P<template_id>\d+)/$', task_schedule, name='task_schedule'),
    url(r'^task_schedule_csv/(?P<template_id>\d+)/$', task_schedule_csv, name='task_schedule_csv'),


] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

volunteers/models.py
from django.conf import settings
from django.contrib.auth.models import User
from django.core.mail import send_mail
from django.db import models
from django.db.utils import OperationalError
from django.utils.translation import ugettext_lazy as _
from userena.models import UserenaLanguageBaseProfile

import datetime
# from dateutil import relativedelta
import hashlib
import httplib
import os
import urllib
import vobject
import xml.etree.ElementTree as ET


# Parse dates, times, DRY
def parse_datetime(date_str, format='%Y-%m-%d'):
    return datetime.datetime.strptime(date_str, format)


def parse_date(date_str, format='%Y-%m-%d'):
    return parse_datetime(date_str, format).date()


def parse_time(date_str, format='%H:%M'):
    return parse_datetime(date_str, format).time()


# More DRY: given a start hour and duration, return start and end time.
def parse_hour_duration(start_str, duration_str, format='%H:%M'):
    start = datetime.datetime.strptime(start_str, format)
    dur_tm = datetime.datetime.strptime(duration_str, format)
    duration = datetime.timedelta(hours=dur_tm.hour, minutes=dur_tm.minute, seconds=dur_tm.second)
    end = start + duration
    start_tm = datetime.time(hour=start.hour, minute=start.minute, second=start.second)
    end_tm = datetime.time(hour=end.hour, minute=end.minute, second=end.second)
    return (start_tm, end_tm)


# Helper model
# class HasLinkField():
#    def link(self):
#        return 'Link'


# Create your models here.

class Edition(models.Model):
    class Meta:
        verbose_name = _('Edition')
        verbose_name_plural = _('Editions')
        ordering = ['-start_date']

    def __unicode__(self):
        return self.name

    name = models.CharField(max_length=128)
    start_date = models.DateField()
    end_date = models.DateField()
    visible_from = models.DateField()
    visible_until = models.DateField()

    @classmethod
    def get_current(cls):
        retval = False
        today = datetime.date.today()

        try:
            current = cls.objects.filter(visible_from__lte=today, visible_until__gte=today)
            if current: retval = current[0]
            return retval
        except OperationalError:
            pass

    @classmethod
    def penta_create_or_update(cls, xml):
        ed_name = xml.find('title').text
        start_date = parse_date(xml.find('start').text)
        end_date = parse_date(xml.find('end').text)
        visible_from = datetime.date(year=start_date.year - 1, month=8, day=1)
        visible_until = datetime.date(year=start_date.year, month=7, day=31)
        editions = cls.objects.filter(name=ed_name)
        if len(editions):
            edition = editions[0]
        else:
            edition = cls(name=ed_name)  # create if required
        edition.start_date = start_date
        edition.end_date = end_date
        edition.visible_from = visible_from
        edition.visible_until = visible_until
        edition.save()
        return edition

    @classmethod
    def init_generic_tasks(cls):
        edition = cls.get_current()
        if edition:
            generic_task_tree = ET.parse('volunteers/init_data/generic_tasks.xml')
            generic_task_root = generic_task_tree.getroot()
            for task in generic_task_root.findall('task'):
                Task.create_from_xml(task, edition)

    @classmethod
    def create_from_task_list(cls, file_name):
        print("Importing files from file: {}".format(file_name))
        edition = cls.get_current()
        if edition:
            generic_task_tree = ET.parse(file_name)
            generic_task_root = generic_task_tree.getroot()
            for task in generic_task_root.findall('task'):
                Task.create_from_xml(task, edition)

"""
Categories are things like buildup, cleanup, moderation, ...
"""


class TaskCategory(models.Model):
    class Meta:
        verbose_name = _('Task Category')
        verbose_name_plural = _('Task Categories')
        ordering = ['name']

    def __unicode__(self):
        return self.name

    name = models.CharField(max_length=50)
    description = models.TextField()
    volunteers = models.ManyToManyField('Volunteer', through='VolunteerCategory', blank=True, null=True)
    active = models.BooleanField(default=True)

    def assigned_volunteers(self):
        return self.volunteer_set.count()

    def link(self):
        return 'Link'

    @classmethod
    def create_or_update_named(cls, name):
        categories = TaskCategory.objects.filter(name=name)
        if len(categories):
            category = categories[0]
        else:
            category = cls(name=name)
            category.save()
        return category


"""
A task template contains all the data about a task that isn't task specific.
For example, cleanup can happen in multiple locations or at multiple times.
Not sure we need this, but it seemed like a good thing to have when I wrote
down the DB model. ;)
"""


class TaskTemplate(models.Model):
    class Meta:
        verbose_name = _('Task Template')
        verbose_name_plural = _('Task Templates')
        ordering = ['name']

    def __unicode__(self):
        return self.name

    name = models.CharField(max_length=50)
    description = models.TextField()
    category = models.ForeignKey(TaskCategory)
    primary = models.ForeignKey(User, default=1, limit_choices_to={'is_staff': True})

    def link(self):
        return 'Link'

    @classmethod
    def create_or_update_named(cls, name):
        templates = cls.objects.filter(name=name)
        if len(templates):
            template = templates[0]
        else:
            template = cls(name=name)
            category = TaskCategory.create_or_update_named(name)
            template.category = category
            template.save()
        return template


"""
Contains the specifics of an instance of a task. It's based on a task template
but it can override the name and description, yet not the category.
"""


# class Task(models.Model, HasLinkField):
class Task(models.Model):
    class Meta:
        verbose_name = _('Task')
        verbose_name_plural = _('Tasks')
        ordering = ['date', 'start_time', '-end_time', 'name']

    def __unicode__(self):
        day = self.date.strftime('%a')
        start = self.start_time.strftime('%H:%M')
        end = self.end_time.strftime('%H:%M')
        return "%s - %s (%s, %s - %s)" % (self.edition.name, self.name, day, start, end)

    name = models.CharField(max_length=300)
    # For auto-importing; otherwise we can't have multiple cloak room and
    # infodesk tasks if we do a simple name search in create_from_xml
    counter = models.CharField(max_length=2)
    description = models.TextField()
    date = models.DateField()
    start_time = models.TimeField()
    end_time = models.TimeField()
    nbr_volunteers = models.IntegerField(default=0)
    nbr_volunteers_min = models.IntegerField(default=0)
    nbr_volunteers_max = models.IntegerField(default=0)
    edition = models.ForeignKey(Edition, default=Edition.get_current())
    template = models.ForeignKey(TaskTemplate)
    volunteers = models.ManyToManyField('Volunteer', through='VolunteerTask', blank=True, null=True)

    def assigned_volunteers(self):
        return self.volunteer_set.count()

    def link(self):
        return 'Link'

    @classmethod
    def create_from_xml(cls, xml, edition):
        template_str = xml.get('template')
        template = TaskTemplate.create_or_update_named(template_str)
        name = xml.find('name').text
        counter = xml.find('counter').text
        tasks = cls.objects.filter(name=name, counter=counter, template=template, edition=edition)
        if len(tasks):
            task = tasks[0]
            # In this specific model I do not want to update after initial import
            return task
        else:
            task = cls(name=name, counter=counter, template=template, edition=edition)
        task.description = xml.find('description').text
        day_offset = int(xml.find('day').text)
        task.date = edition.start_date + datetime.timedelta(days=day_offset)
        task.start_time = parse_time(xml.find('start_time').text)
        task.end_time = parse_time(xml.find('end_time').text)
        task.nbr_volunteers = int(xml.find('nbr_volunteers').text)
        task.nbr_volunteers_min = int(xml.find('nbr_volunteers_min').text)
        task.nbr_volunteers_max = int(xml.find('nbr_volunteers_max').text)
        task.save()
        return task


"""
table to contain the language names and ISO codes
"""


class Language(models.Model):
    class Meta:
        verbose_name = _('Language')
        verbose_name_plural = _('Languages')

    def __unicode__(self):
        return self.name

    name = models.CharField(max_length=128)
    iso_code = models.CharField(max_length=2)


"""
The nice guys n' gals who make it all happen.
"""


class Volunteer(UserenaLanguageBaseProfile):
    class Meta:
        verbose_name = _('Volunteer')
        verbose_name_plural = _('Volunteers')
        ordering = ['user__first_name', 'user__last_name']

    def __unicode__(self):
        return self.user.username

    ratings = (
        (0, 'No longer welcome'),
        (1, 'Poor'),
        (2, 'Not great'),
        (3, 'Average'),
        (4, 'Good'),
        (5, 'Superb'),
    )

    user = models.OneToOneField(User, unique=True, verbose_name=_('user'), related_name='volunteer')
    # Categories in which they're interested to help out.
    categories = models.ManyToManyField(TaskCategory, through='VolunteerCategory', blank=True, null=True, \
                                        help_text="""<br/><br/>
        Indicate your preference for which kind of tasks you'd prefer to do.
        The tasks belonging to this category will appear on top in the Tasks page, so you
        can find them easily.<br/><br/>
        Signing up for actual tasks does not happen here; that's done in the Tasks screen!""")

volunteers/templates/volunteers/category_schedule_list.html
{% extends 'userena/base_userena.html' %}
{% load i18n %}
{% load volunteer_extras %}

{% block content_title %}<h2 class="content-title">{% trans 'Categories' %}</h2>{% endblock %}

{% block content %}
    {% for category, templates in categories.items %}
    <h2>Category: {{ category.name }}</h2>
    <ul>
        {% for template in templates %}

        <li><a href="{% url 'task_schedule' template.id %}" title="View Schedule">{{ template.name }}</a></li>
        {% endfor %}
    </ul>
    <br/>
    {% endfor %}
{% endblock %}

volunteers/templates/volunteers/task_detailed.html
{% extends 'userena/base_userena.html' %}
{% load i18n %}
{% load volunteer_extras %}

{% block content_title %}<h2 class="content-title">{% trans 'Task' %}</h2>{% endblock %}

{% block content %}
<form class="task_list">{% csrf_token %}
    <fieldset>
        <legend class="task_list">{% trans 'Task' %}</legend>
        <table class="task_list">
            <tr>
                <th width="20%">{% trans 'When' %}</th>
                <th width="60%">{% trans 'Title' %}</th>
                <th width="20%">{% trans 'Attending' %}</th>
            </tr>
            <tr>
                <td>{{ task.date|date:"D" }}, {{ task.start_time|time:"H:i" }} - {{ task.end_time|time:"H:i" }}</td>
                <td>{{ task.name }}</td>
                <td>
                    {% if user.is_authenticated %}
                    {% for volunteer in task.volunteer_set.all %}
                        <a href="{% url 'profile_detail' volunteer.user.username %}">{{ volunteer.user.first_name }} {{ volunteer.user.last_name }},</a>
                    {% endfor %}
                    {% else %}
                        {{ task.volunteer_set.count}}/{{ task.nbr_volunteers }}
                    {% endif%}
            </tr>
            <tr>
                <th colspan="4" style="border-bottom: none;">&nbsp;</th>
            </tr>
            <tr>
                <td colspan="4">{{ task.description|linebreaksbr }}</td>
            </tr>
        </table>
        <br>
    </fieldset>
</form>

<div id="dialog" title="Task"></div>
{% endblock %}

volunteers/templates/volunteers/task_schedule.html
{% extends 'userena/base_userena.html' %}
{% load i18n %}
{% load volunteer_extras %}

{% block content_title %}<h2 class="content-title">{{ template.name }} {% trans 'Schedule' %}</h2>{% endblock %}

{% block content %}
    <form action="{% url 'task_schedule_csv' template.id %}" class="button">
        <input type="submit" value="Export CSV"/>
    </form>
    {% for task, volunteers in tasks.items %}
    <h2 class="task-title">
        {{ task.name }} ({{task.assigned_volunteers}}/{{task.nbr_volunteers}})<br/>
        {{ task.date|date:"l" }}, {{ task.start_time|time:"H:i" }} - {{ task.end_time|time:"H:i" }}
    </h2><br/>
    <table width="98%" class="task_schedule">
        <tr><td colspan="4">&nbsp;</td></tr>
        {% for volunteer in volunteers %}
        <tr>
            <td class="task_schedule_head" width="20%">{{ volunteer.user.first_name }} {{ volunteer.user.last_name }}</td>
            <td class="task_schedule_head" width="50%">
                {{ task.date|date:"l" }}, {{ task.start_time|time:"H:i" }} - {{ task.end_time|time:"H:i" }}
            </td>
            <td class="task_schedule_head">Present?</td>
            <td class="task_schedule_head_avatar">&nbsp;</td>
        </tr>
        <tr>
            <td class="task_schedule">
                Nick:<br/>
                Email:<br/>
                Mobile:<br/>
            </td>
            <td class="task_schedule">
                {{ volunteer.user.username }}<br/>
                {{ volunteer.user.email }}<br/>
                {{ volunteer.mobile_nbr }}
            </td>
            <td>&nbsp;</td>
            <td class="task_schedule">
                <img src="{{ volunteer.get_mugshot_url }}" class="avatar_center"/>
            </td>
        </tr>
        <tr><td colspan="4">&nbsp;</td></tr>
        {% endfor %}
    </table>
    <br/>&nbsp;<br/>
    {% endfor %}
{% endblock %}

volunteers/templates/volunteers/tasks.html
{% extends 'userena/base_userena.html' %}
{% load i18n %}
{% load volunteer_extras %}

{% block content_title %}<h2 class="content-title">{% trans 'Tasks' %}</h2>{% endblock %}

{% block content %}
{% if user.is_authenticated %}<a class="larger-font" href="{% url 'task_list_detailed' user.username %}" title="View schedule">View your schedule</a>{% endif %}
<form class="task_list" action="{% url 'task_list' %}" method="post">{% csrf_token %}
    {% if is_dr_manhattan %}
    <fieldset>
        <legend class="task_list">We seem to have a bit of a problem here...</legend><br/>
        <table>
            <tr>
                <td><img src="http://nighty.safehex.be/linked_pics/dr_manhattan.png"/></td>
                <td width="20px;">&nbsp;</td>
                <td style="vertical-align: top;">
                    Unless you look like the guy on the left, odds are you're not actually capable
                    of being in two different locations at the same time. So it might be wise to take
                    action on the tasks below...
                </td>
                <td width="50%">&nbsp;</td>
            </tr>
        </table><br/>
        <table class="task_list">
            <thead>
                <tr class="table_top_alert">
                    <th width="10%">{% trans "I'm in" %}!</th>
                    <th width="55%">{% trans 'Task' %}</th>
                    <th width="20%">{% trans 'When' %}</th>
                    <th width="15%">{% trans 'Volunteers' %}</th>
                </tr>
            </thead>
            <tbody>
                {% for task_set in dr_manhattan_tasks %}
                    <tr class="task_set_alert">
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">Problematic tasks #{{ forloop.counter }}:</th>
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">&nbsp;</th>
                    </tr>
                    {% for task in task_set %}
                    <tr>
                        <td {% if user.is_authenticated %}data-title="{% trans 'I am in' %}!"{% endif %}>{% if user.is_authenticated %}<input type="checkbox" name="task" value="{{ task.id }}" {{ checked|get_item:task.id }} />{% endif %}</td>
                        {% if attending|get_item:task.id == True %}
                        <td class="task-name special-task">{{ task.name }} <span class="small_note">(Hey, you're attending this!)</span></td>
                        {% else %}
                        <td data-title="{% trans 'Task' %}" class="task-name"><a href="{% url 'task_detailed' task.id %}">{{ task.name }}</a></td>
                        {% endif %}
                        <td data-title="{% trans 'When' %}" >{{ task.date|date:"D" }}, {{ task.start_time|time:"H:i" }} - {{ task.end_time|time:"H:i" }}</td>
                        {% if task.assigned_volunteers >= task.nbr_volunteers_max %}
                        <td data-title="{% trans 'Volunteers' %}" class="task-volunteers blue" title="{% trans 'Full' %}
                        {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                        {% elif task.assigned_volunteers >= task.nbr_volunteers %}
                        <td data-title="{% trans 'Volunteers' %}" class="task-volunteers green" title="{% trans 'Staffed' %}
                        {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                        {% elif task.assigned_volunteers >= task.nbr_volunteers_min %}
                        <td data-title="{% trans 'Volunteers' %}" class="task-volunteers gray" title="{% trans 'Manageable' %}
                        {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                        {% else %}
                        <td data-title="{% trans 'Volunteers' %}" class="task-volunteers red" title="{% trans 'More volunteers needed' %}
                            {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %} {% endif%}">
                        {% endif %}
                        {{task.assigned_volunteers}}/{{ task.nbr_volunteers }}</td>
                    </tr>
                    {% endfor %}
                {% endfor %}
            </tbody>
        </table>
    </fieldset>
    {% endif %}

    {% if not setup_for_current_year_complete %}
        <legend class="task_list">We're still setting up the system for this year's edition!</legend><br/>
        <table>
            <tr>
                <td><img style="height: 100px;" src="http://icons.iconarchive.com/icons/graphicloads/100-flat/256/warning-icon.png"/></td>
                <td width="20px;">&nbsp;</td>
                <td style="vertical-align: middle;">
                  We're still in the middle of getting all the tasks populated for this year's edition. <strong>Please check back before the event</strong> - there will be (a lot) more to do than what is listed below!
                </td>
            </tr>
        </table>
    {% endif %}

    {% for title, days in tasks.items %}
    <fieldset>
        <legend class="task_list">{% trans title %} <span style="font-size: small; font-weight: normal;">
            {% if user.is_authenticated %}{% if title == 'preferred tasks' %}
            (<a class="larger-font" href="{% url 'userena_profile_edit' user.username %}">{% trans 'Change in profile' %}</a>)
            {% endif %}{% endif %}
        </span></legend>
        <table class="task_list">
            <thead>
                <tr class="table_top">
                    <th width="10%">{% trans "I'm in" %}!</th>
                    <th width="55%">{% trans 'Task' %}</th>
                    <th width="20%">{% trans 'When' %}</th>
                    <th width="15%">{% trans 'Volunteers' %}</th>
                </tr>
            </thead>
            <tbody>
                {% for day, categories in days.items %}
                {% if categories.items %}
                {% ifchanged %}
                {% else %}
                <tr class="row-hide">
                    <th class="no_vert_border">&nbsp;</th>
                    <th class="no_vert_border">&nbsp;</th>
                    <th class="no_vert_border">&nbsp;</th>
                    <th class="no_vert_border">&nbsp;</th>
                </tr>
                {% endifchanged %}
                <tr class="day">
                    <th class="no_vert_border">{{ day|date:"l (m/d)" }}</th>
                    <th class="no_vert_border">&nbsp;</th>
                    <th class="no_vert_border">&nbsp;</th>
                    <th class="no_vert_border">&nbsp;</th>
                </tr>
                    {% for category, category_tasks in categories.items %}
                    {% if category_tasks %}
                    {% ifchanged %}
                    {% else %}
                    <tr class="row-hide">
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">&nbsp;</th>
                    </tr>
                    {% endifchanged %}
                    <tr class="category">
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">{{ category.name }}</th>
                        <th class="no_vert_border">&nbsp;</th>
                        <th class="no_vert_border">&nbsp;</th>
                    </tr>
                        {% for task in category_tasks %}
                        <tr>
                            <td {% if user.is_authenticated %}data-title="{% trans 'I am in' %}!"{% endif %}>{% if user.is_authenticated %}<input type="checkbox" name="task" value="{{ task.id }}" {{ checked|get_item:task.id }} />{% endif %}</td>
                            {% if attending|get_item:task.id == True %}
                            <td class="task-name special-task">{{ task.name }} <span class="small_note">(Hey, you're attending this!)</span></td>
                            {% else %}
                            <td data-title="{% trans 'Task' %}" class="task-name"><a href="{% url 'task_detailed' task.id %}">{{ task.name }}</a></td>
                            {% endif %}
                            <td data-title="{% trans 'When' %}">{{ task.date|date:"D" }}, {{ task.start_time|time:"H:i" }} - {{ task.end_time|time:"H:i" }}</td>
                            {% if task.assigned_volunteers == task.nbr_volunteers_max %}
                            <td data-title="{% trans 'Volunteers' %}" class="task-volunteers blue" title="{% trans 'Full' %}
                            {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                            {% elif task.assigned_volunteers >= task.nbr_volunteers %}
                            <td data-title="{% trans 'Volunteers' %}" class="task-volunteers green" title="{% trans 'Staffed' %}
                            {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                            {% elif task.assigned_volunteers >= task.nbr_volunteers_min %}
                            <td data-title="{% trans 'Volunteers' %}" class="task-volunteers gray" title="{% trans 'Manageable' %}
                            {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                            {% else %}
                            <td data-title="{% trans 'Volunteers' %}" class="task-volunteers red" title="{% trans 'More volunteers needed' %}
                            {% if user.is_authenticated %}<br/><br/>Signed up:<br/>{% for volunteer in task.volunteers.all %}* {{ volunteer.user.first_name }} {{ volunteer.user.last_name}} ({{ volunteer.user }})<br/>{% endfor %}{% endif %}">
                            {% endif %}
                            {{task.assigned_volunteers}}/{{ task.nbr_volunteers }}</td>
                        </tr>
                        {% endfor %}
                    {% endif %}
                    {% endfor %}
                {% endif %}
                {% endfor %}
            </tbody>
        </table>
        <br>
    </fieldset>
    {% endfor %}
    {% if user.is_authenticated %}
    <input type="submit" value="{% trans "Save changes" %}" />
    {% endif %}
</form>

<div id="dialog" title="Task"></div>

{% if is_paginated %}
<div class="pagination">
    <span class="step-links">
        {% if page_obj.has_previous %}
        <a href="{% url 'userena_profile_list_paginated' page_obj.previous_page_number %}">{% trans 'previous' %}</a>
        {% endif %}

        <span class="current">
            {% trans 'Page' %} {{ page_obj.number }} {% trans 'of' %} {{ page_obj.paginator.num_pages }}.
        </span>

        {% if page_obj.has_next %}
        <a href="{% url 'userena_profile_list_paginated'  page_obj.next_page_number %}">{% trans 'next' %}</a>
        {% endif %}
    </span>
</div>
{% endif %}
{% endblock %}